# -*- coding: utf-8 -*-
# Generated by Django 1.11.17 on 2021-09-22 19:20
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ('customers', '0062_auto_20210805_1021'),
    ]
    sql = """
CREATE OR REPLACE VIEW public.customers_financialrecordservice AS 
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    false AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_credit,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind <> 3 AND customers_invoice.kind <> 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind = 3 OR customers_invoice.kind = 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS credit,
    customers_invoice.tasa,
    customers_invoice.comment,
    customers_invoice.customer_id,
    customers_invoice_service.service_id
   FROM customers_invoice,
    customers_invoice_service
  WHERE customers_invoice_service.invoice_id = customers_invoice.id AND customers_invoice.paid_on IS NULL
  GROUP BY customers_invoice.id, customers_invoice_service.id
UNION
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    true AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_credit,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind <> 3 AND customers_invoice.kind <> 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind = 3 OR customers_invoice.kind = 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS credit,
    customers_invoice.tasa,
    customers_invoice.comment,
    customers_invoice.customer_id,
    customers_invoice_service.service_id
   FROM customers_invoice,
    customers_invoice_service
  WHERE customers_invoice_service.invoice_id = customers_invoice.id AND customers_invoice.paid_on IS NOT NULL
  GROUP BY customers_invoice.id, customers_invoice_service.id
UNION
 SELECT 'P'::text || customers_payment.id::text AS record_id,
    true AS paid,
    customers_payment.paid_on AS ts,
    NULL::integer AS original_charge,
    customers_payment.amount AS original_credit,
    NULL::integer AS charge,
        CASE
            WHEN customers_payment.tasa IS NULL THEN customers_payment.amount
            WHEN customers_payment.tasa IS NOT NULL THEN sum(customers_payment.amount*customers_payment.tasa)
            ELSE NULL::integer
        END AS credit,
    customers_payment.tasa,
    customers_payment.comment,
    customers_payment.customer_id,
    customers_payment_service.service_id
   FROM customers_payment,
    customers_payment_service
  WHERE customers_payment_service.payment_id = customers_payment.id
  GROUP BY customers_payment.id, customers_payment_service.id
  ORDER BY 3 DESC
    """

    balance_sql = """
    CREATE VIEW  customers_balanceservice AS SELECT fr.customer_id AS id, fr.customer_id, COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance, fr.service_id FROM customers_financialrecordservice fr GROUP BY fr.customer_id, fr.service_id
    """
    sql2 = """
CREATE OR REPLACE VIEW public.customers_financialrecord AS 
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    false AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_credit,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind <> 3 AND customers_invoice.kind <> 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind = 3 OR customers_invoice.kind = 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS credit,
    customers_invoice.tasa,
    customers_invoice.comment,
    customers_invoice.customer_id
   FROM customers_invoice
  WHERE customers_invoice.paid_on IS NULL
  GROUP BY customers_invoice.id
UNION
 SELECT 'I'::text || customers_invoice.id::text AS record_id,
    true AS paid,
    customers_invoice.created_at AS ts,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 THEN customers_invoice.total
            ELSE NULL::integer
        END AS original_credit,
        CASE
            WHEN customers_invoice.kind <> 3 AND customers_invoice.kind <> 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind <> 3 AND customers_invoice.kind <> 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN customers_invoice.kind = 3 OR customers_invoice.kind = 9 AND customers_invoice.tasa IS NULL THEN customers_invoice.total
            WHEN (customers_invoice.kind = 3 OR customers_invoice.kind = 9) AND customers_invoice.tasa IS NOT NULL THEN sum(customers_invoice.total*customers_invoice.tasa)
            ELSE NULL::integer
        END AS credit,
    customers_invoice.tasa,
    customers_invoice.comment,
    customers_invoice.customer_id
   FROM customers_invoice
  WHERE customers_invoice.paid_on IS NOT NULL
  GROUP BY customers_invoice.id
UNION
 SELECT 'P'::text || customers_payment.id::text AS record_id,
    true AS paid,
    customers_payment.paid_on AS ts,
    NULL::integer AS original_charge,
    customers_payment.amount AS original_credit,
    NULL::integer AS charge,
    CASE
            WHEN customers_payment.tasa IS NULL THEN customers_payment.amount
            WHEN customers_payment.tasa IS NOT NULL THEN sum(customers_payment.amount*customers_payment.tasa)
            ELSE NULL::integer
        END AS credit,
    customers_payment.tasa,
    customers_payment.comment,
    customers_payment.customer_id
   FROM customers_payment
   GROUP BY customers_payment.id
  ORDER BY 3 DESC
    """

    balance_sql2 = """
    CREATE OR REPLACE VIEW public.customers_balance AS 
 SELECT c.id,
    c.id AS customer_id,
    COALESCE(sum(fr.credit), 0::bigint) - COALESCE(sum(fr.charge), 0::bigint) AS balance
   FROM customers_customer c
     LEFT JOIN customers_financialrecord fr ON c.id = fr.customer_id
  GROUP BY c.id """
    vista="""
CREATE OR REPLACE VIEW public.vista AS 
 SELECT customers_invoice.due_date AS ts,
        CASE
            WHEN customers_invoice.kind <> 3 THEN customers_invoice.total
            ELSE NULL::integer
        END AS charge,
        CASE
            WHEN customers_invoice.kind = 3 THEN customers_invoice.total
            ELSE NULL::integer
        END AS credit,
    customers_invoice.comment,
    customers_invoice.customer_id
   FROM customers_invoice
UNION
 SELECT customers_payment.paid_on AS ts,
    NULL::integer AS charge,
    customers_payment.amount AS credit,
    customers_payment.comment,
    customers_payment.customer_id
   FROM customers_payment
  ORDER BY 1 DESC
 LIMIT 10"""
    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS customers_balanceservice"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_financialrecordservice"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_balance"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_financialrecord"),
        migrations.RunSQL("DROP VIEW IF EXISTS vista"),
        migrations.AddField(
            model_name='company',
            name='currency',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='historicalcompany',
            name='currency',
            field=models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Currency'),
        ),
        migrations.AddField(
            model_name='historicalinvoice',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='historicalpayment',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='invoice',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AddField(
            model_name='payment',
            name='tasa',
            field=models.DecimalField(blank=True, decimal_places=5, max_digits=20, null=True, verbose_name='tasa'),
        ),
        migrations.AlterField(
            model_name='cartola',
            name='saldo_final',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Saldo final'),
        ),
        migrations.AlterField(
            model_name='cartola',
            name='saldo_inicial',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Saldo inicial'),
        ),
        migrations.AlterField(
            model_name='cartola',
            name='total_abono',
            field=models.DecimalField(decimal_places=2, max_digits=12, null=True, verbose_name='Total Abonos y Depositos'),
        ),
        migrations.AlterField(
            model_name='cartola',
            name='total_cargo',
            field=models.DecimalField(decimal_places=2, max_digits=12, null=True, verbose_name='Saldo final'),
        ),
        migrations.AlterField(
            model_name='cartolamovement',
            name='saldo_diario',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Saldo diario'),
        ),
        migrations.AlterField(
            model_name='cartolamovement',
            name='total',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Total'),
        ),
        migrations.AlterField(
            model_name='historicalcartola',
            name='saldo_final',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Saldo final'),
        ),
        migrations.AlterField(
            model_name='historicalcartola',
            name='saldo_inicial',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Saldo inicial'),
        ),
        migrations.AlterField(
            model_name='historicalcartola',
            name='total_abono',
            field=models.DecimalField(decimal_places=2, max_digits=12, null=True, verbose_name='Total Abonos y Depositos'),
        ),
        migrations.AlterField(
            model_name='historicalcartola',
            name='total_cargo',
            field=models.DecimalField(decimal_places=2, max_digits=12, null=True, verbose_name='Saldo final'),
        ),
        migrations.AlterField(
            model_name='historicalcartolamovement',
            name='saldo_diario',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Saldo diario'),
        ),
        migrations.AlterField(
            model_name='historicalcartolamovement',
            name='total',
            field=models.DecimalField(decimal_places=2, max_digits=12, verbose_name='Total'),
        ),
        migrations.AlterField(
            model_name='historicalindicators',
            name='kind',
            field=models.PositiveSmallIntegerField(choices=[(1, 'Unidad de fomento (UF)'), (2, 'Impuesto sobre el Valor Agregado (IVA)'), (3, 'Dólar observado'), (4, 'Dólar acuerdo'), (5, 'Euro'), (6, 'Unidad Tributaria Mensual (UTM)'), (7, 'Tasa Política Monetaria (TPM)'), (8, 'Bitcoin'), (9, 'Peso chileno (CLP)'), (10, 'Soles peruanos (PEN)')], default=1, verbose_name='kind'),
        ),
        migrations.AlterField(
            model_name='historicalindicators',
            name='value',
            field=models.DecimalField(decimal_places=6, max_digits=20, verbose_name='value'),
        ),
        migrations.AlterField(
            model_name='historicalinvoice',
            name='total',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='total'),
        ),
        migrations.AlterField(
            model_name='historicalpayment',
            name='amount',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='payment amount'),
        ),
        migrations.AlterField(
            model_name='indicators',
            name='kind',
            field=models.PositiveSmallIntegerField(choices=[(1, 'Unidad de fomento (UF)'), (2, 'Impuesto sobre el Valor Agregado (IVA)'), (3, 'Dólar observado'), (4, 'Dólar acuerdo'), (5, 'Euro'), (6, 'Unidad Tributaria Mensual (UTM)'), (7, 'Tasa Política Monetaria (TPM)'), (8, 'Bitcoin'), (9, 'Peso chileno (CLP)'), (10, 'Soles peruanos (PEN)')], default=1, verbose_name='kind'),
        ),
        migrations.AlterField(
            model_name='indicators',
            name='value',
            field=models.DecimalField(decimal_places=6, max_digits=20, verbose_name='value'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='total',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='total'),
        ),
        migrations.AlterField(
            model_name='payment',
            name='amount',
            field=models.DecimalField(decimal_places=2, default=0, max_digits=12, verbose_name='payment amount'),
        ),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql),
        migrations.RunSQL(sql2),
        migrations.RunSQL(balance_sql2),
        migrations.RunSQL(vista),
    ]
